// spica javascript libraries - stylesheet.js
// == written by Takuya Otani <takuya.otani@gmail.com> ===
// == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

Spica.StyleSheets = function()
{
	this.sheets = [];
	this.preferred = null;
	this.active = null;
	return this._init();
}
Spica.StyleSheets.prototype = {
	_init : function()
	{
		var links = document.getElementsByTagName('link');
		var check = document.styleSheets;
		if (check)
		{ // There is styleSheets object.
			for (var i=0,n=check.length;i<n;i++)
			{
				if (!check[i].title) continue;
				var item = { title:check[i].title, entity:check[i] };
				this.sheets.push(item);
			}
		}
		for (var i=0,n=links.length;i<n;i++)
		{
			if (links[i].getAttribute('rel').indexOf('style') == -1) continue;
			if (!links[i].getAttribute('title')) continue;
			if (!check)
			{
				var item = { title:links[i].getAttribute('title'), entity:links[i] };
				this.sheets.push(item);
			}
			if (links[i].getAttribute('rel').indexOf('alt') == -1) // not alternative
				this.preferred = links[i].getAttribute('title');
		}
		return this;
	},
	set_active : function(title)
	{
		if (this.active == title) return; // nothing to do
		for (var i=0,n=this.sheets.length;i<n;i++)
		{
			if (this.sheets[i].title == title)
				this.sheets[i].entity.disabled = false;
			else
				this.sheets[i].entity.disabled = true;
		}
		this.active = title;
	},
	add : function(path,title,attr)
	{
		if (!path) return;
		var style = document.createElement('link');
		style.setAttribute('rel','stylesheet');
		style.setAttribute('type','text/css');
		style.setAttribute('href',path);
		style.setAttribute('title',(title) ? title : '');
		style.setAttribute('media','screen');
		if (attr.length > 0)
		{
			for (var i=0,n=attr.length;i<n;i++)
			{
				if (!attr[i][0]) continue;
				style.setAttribute(attr[i][0],attr[i][1]);
			}
		}
		document.getElementsByTagName('head')[0].appendChild(style);
	}
};
